// tomedo url scheme
var tomedoUrlScheme = 'zswebformscheme';
var PRODUCTION_MODE = true;

var canvases = {};
var formdataDict = {};
var patientenanschrift;

var formformComplete;
var isFormLocked = false;

// --------------------------------------------------------------------------------
// initializer/setup function:
// --------------------------------------------------------------------------------

function appInit() {

	$("#resetButton").on("click",function(){
		resetButtonClicked();
	});

    $("#tomedoButton").on("click", function() {
        showSaveModal();
    });

    /*
	$("#testButton").on("click",function(){
		setupForLockedForm();
	});
*/

    $("#modalBackWithoutSaveButton").on("click", function() {
        requestBackWithoutSave();
    });
    $("#modalConfirmSaveButton").on("click", function() {
        saveFormToTomedo();
    });
    $("#modalConfirmSaveAndLockButton").on("click", function() {
        saveLockedFormToTomedo();
    });

    $("#modalzurueckZuTomedoButton").on("click", function() {

        if (PRODUCTION_MODE) {
            requestCloseWithoutPin();
        }
    });

    // modalPrintButton
    $("#modalPrintButton").on("click", function() {
        requestPrint();
    });


    if (isFormLocked) {
        setupForLockedForm();
    }
    else {
        $("canvas").each(function() {
            setupCanvas(this);
        });

        $(".input-group.date").datepicker({
            format: "dd.mm.yyyy",
            startView: 1,
            todayBtn: "linked",
            language: "de",
            calendarWeeks: true,
            autoclose: true,
            todayHighlight: true
        });
    }
	
}

// --------------------------------------------------------------------------------
// canvas functions:
// --------------------------------------------------------------------------------

function setupCanvas(canvas) {

    userAgent = window.navigator.userAgent;
    if (/iP(hone|od|ad)/.test(userAgent)) {
        drawTouch(canvas);
    }
    else {
        drawMouse(canvas);
    }
}

// if we reset a canvas, we also need to reset the associated array of lines
function resetCanvasAndEmptyLinesArray(canvas) {

    userAgent = window.navigator.userAgent;
    if (/iP(hone|od|ad)/.test(userAgent)) {
        drawTouch(canvas);
    }
    else {
        drawMouse(canvas);
    }
}

function context2dForCanvas(canvas) {

    var ctx = canvas.getContext("2d");
    ctx.fillStyle = "solid";
    ctx.strokeStyle = "#000";
    ctx.lineWidth = 2;
    ctx.lineCap = "round";

    return ctx;
}

// prototype to	start drawing on touch using canvas moveTo and lineTo
var drawTouch = function(canvas) {

    console.log('drawTouch canvas', canvas);

    var lines;
    // create an array of lines for the current canvas
    if (canvases[canvas.id]) {
        lines = canvases[canvas.id];
        if (lines.length < 1) {
            lines = new Array();
            // add the array to the global dict of canvases
            canvases[canvas.id] = lines;
        }
    }
    else {
        lines = new Array();
        // add the array to the global dict of canvases
        canvases[canvas.id] = lines;
    }

    console.log('drawTouch canvases: ' + JSON.stringify(canvases));

    // each time of touch start we create a new line and store it to the list of lines
    var currentLine;

    var ctx = context2dForCanvas(canvas);

    // set canvas background color and fill the canvas
    //    ctx.fillStyle   = 'white';
    //    ctx.fillRect  (0,   0, canvas.width, canvas.height);

    var pos;

    var start = function(e) {

        ctx.beginPath();

        pos = getTouchPosition(canvas, e);
        ctx.moveTo(pos.x, pos.y);

        // add the coordinates to the currentLine
        currentLine = new Array();
        console.log('drawTouch start: currentLine: ' + JSON.stringify(currentLine));
        console.log('drawTouch start: pos: ' + JSON.stringify(pos));

        lines.push(currentLine);
        currentLine.push(pos);
        console.log('drawTouch start: currentLine: ' + currentLine);

        console.log('drawTouch start: x:' + pos.x + ' y:' + pos.y);
        console.log('drawTouch start: canvases: ' + canvases);
    };
    var move = function(e) {
        e.preventDefault();

        pos = getTouchPosition(canvas, e);
        ctx.lineTo(pos.x, pos.y);
        ctx.stroke();

        // add the coordinates to the currentLine
        currentLine.push(pos);
        console.log('drawTouch move: currentLine: ' + currentLine);

        console.log('drawTouch move: x:' + pos.x + ' y:' + pos.y);
        console.log('drawTouch move: canvases: ' + canvases);
    };

    canvas.addEventListener("touchstart", start, false);
    canvas.addEventListener("touchmove", move, false);
};

function getTouchPosition(canvas, e) {

    var rect = canvas.getBoundingClientRect();

    console.log('pageX:' + e.changedTouches[0].clientX + ' pageY:' + e.changedTouches[0].clientY + ' rect.left:' + rect.left + ' rect.top:' + rect.top);

    return {
        x: e.changedTouches[0].clientX - rect.left,
        y: e.changedTouches[0].clientY - rect.top
    }
}

// prototype to	start drawing on mouse using canvas moveTo and lineTo
var drawMouse = function(canvas) {

    console.log('drawMouse canvas', canvas);

    var lines;
    // create an array of lines for the current canvas
    if (canvases[canvas.id]) {
        lines = canvases[canvas.id];
        if (lines.length < 1) {
            lines = new Array();
            // add the array to the global dict of canvases
            canvases[canvas.id] = lines;
        }
    }
    else {
        lines = new Array();
        // add the array to the global dict of canvases
        canvases[canvas.id] = lines;
    }

    console.log('drawMouse canvases: ' + JSON.stringify(canvases));

    // each time of touch start we create a new line and store it to the list of lines
    var currentLine;

    var ctx = context2dForCanvas(canvas);

    // set canvas background color and fill the canvas
    //    ctx.fillStyle   = 'white';
    //    ctx.fillRect  (0,   0, canvas.width, canvas.height);

    var pos;

    var clicked = 0;
    var start = function(e) {
        clicked = 1;
        ctx.beginPath();
        pos = getMousePosition(canvas, e);
        ctx.moveTo(pos.x, pos.y);

        // add the coordinates to the currentLine
        currentLine = new Array();
        lines.push(currentLine);
        currentLine.push(pos);

        console.log('drawMouse start: x:' + pos.x + ' y:' + pos.y);
        console.log('drawMouse start: canvases: ' + canvases);
    };
    var move = function(e) {
        if (clicked) {

            pos = getMousePosition(canvas, e);
            ctx.lineTo(pos.x, pos.y);
            ctx.stroke();

            // add the coordinates to the currentLine
            currentLine.push(pos);
            console.log('drawMouse move: x:' + pos.x + ' y:' + pos.y);
            console.log('drawMouse move: canvases: ' + canvases);
        }
    };
    var stop = function(e) {
        clicked = 0;
    };

    canvas.addEventListener("mousedown", start, false);
    canvas.addEventListener("mousemove", move, false);
    document.addEventListener("mouseup", stop, false);
};

function getMousePosition(canvas, e) {

    var rect = canvas.getBoundingClientRect();

    return {
        x: e.clientX - rect.left,
        y: e.clientY - rect.top
    }
}
;

// drawing

function drawLine(canvas, line) {

    if (line.length < 2) {
        return;
    }
    var ctx = context2dForCanvas(canvas);
    console.log('drawLine canvas', canvas);


    var pos = line[0];
    ctx.beginPath();
    ctx.moveTo(pos.x, pos.y);

    for (var i = 1; i < line.length; i++) {

        pos = line[i];
        ctx.lineTo(pos.x, pos.y);
    }
    ctx.stroke();
}

function drawLinesInCanvas(id, lines) {

    if (!lines || lines.length < 1) {
        return;
    }
    var canvas = document.getElementById(id);

    console.log('drawLinesInCanvas canvas', canvas);

    var ctx = context2dForCanvas(canvas);
    /*
	var ctx = canvas.getContext('2d');
	ctx.fillStyle = "solid";
    ctx.strokeStyle = "#000";
    ctx.lineWidth = 2;
    ctx.lineCap = "round";
*/

    // set canvas background color and fill the canvas
    /* ctx.fillStyle = 'white'; */
    ctx.clearRect(0, 0, canvas.width, canvas.height);


    for (var i = 0; i < lines.length; i++) {

        drawLine(canvas, lines[i]);
    }
}

// --------------------------------------------------------------------------------
// debug functions:
// --------------------------------------------------------------------------------

function listAllZSDataObjects() {

    var allObjects = $('.zs-data');

    console.log('listAllZSDataObjects allObjects.length: ' + allObjects.length);

    $(allObjects).each(function(index, element) {

        console.log('index:' + index +
        ' tag:' + element.tagName +
        ' type:' + element.type +
        ' id:' + element.id +
        ' value:' + element.value +
        ' checked:' + element.checked);
    });
}

// --------------------------------------------------------------------------------
// button handler functions:
// --------------------------------------------------------------------------------

function showModal(title, text, cancelCallback, confirmCallback) {

    $('.modal-title').text(title);
    $('.modal-body').text(text);
    $('#modalCancelButton').on('click', cancelCallback);
    $('#modalConfirmButton').on('click', confirmCallback);

    $('#myModal').modal('show');
}

function showSaveModal() {

    if (!isFormComplete()) {
        $('#saveModalHinweis').text('Hinweis: Das Formular ist nicht vollständig ausgefüllt!');
        $('#modalConfirmSaveAndLockButton').prop('disabled', true);
    }
    else {
        $('#saveModalHinweis').text('');
        $('#modalConfirmSaveAndLockButton').prop('disabled', false);
    }
    $('#saveModal').modal('show');
}

function saveFormToTomedo() {

    if (PRODUCTION_MODE) {
        requestSave();
    }
    else {
        saveform();
    }
}

function saveLockedFormToTomedo() {

    isFormLocked = true;
    if (PRODUCTION_MODE) {
        requestSave();
    }
    else {
        saveform();
    }
}

// --------------------------------------------------------------------------------
// validate functions:
// --------------------------------------------------------------------------------

// used by HTML inline script to verify input data of mandatory fields
function validateTextInput(input) {

    var x = $(input).val();

    if (x == null || x == "") {
        console.log('validateTextInput null');
        $(input).addClass('missing');
        formComplete = false;
    }
    else {
        console.log('validateTextInput ' + x);
        $(input).removeClass('missing');
    }
}

// used by HTML inline script to verify input data of mandatory fields
function validateDatePicker(datePicker) {

    var x = $(datePicker).val();

    if (x == null || x == "") {
        console.log('validateDatePicker null');
        $(datePicker).addClass('missing');
        formComplete = false;
    }
    else {
        console.log('validateDatePicker ' + x);
        $(datePicker).removeClass('missing');
    }
}

function validateCanvas(canvas) {

    var content = null;

    var tagName = $(canvas).prop('tagName');

    // canvas stores it's data outside in global dictionary
    if( tagName == 'CANVAS' ) {
        content = canvases[ $(canvas).attr('id') ];
    }

    // iOS replaces canvas by image with click handler
    else if( tagName == 'IMG' ) {
        content = $(canvas).attr('src');
    }

    if (content == null || content == "") {
        console.log('validateCanvas null');
        $(canvas).addClass('missing');
        formComplete = false;
    }
    else {
        console.log('validateCanvas ' + content.length);
        $(canvas).removeClass('missing');
    }
}

// --------------------------------------------------------------------------------
// custom URL interface to app functions:
// --------------------------------------------------------------------------------

// fixes bad custom URL style: equal sign is not allowed in URL path, so add questionmark to handle action as URL parameter, which is allowed
// (this is an issue which started in iOS 10 and macOS 10.12 code)
function fixBadURLString(urlStr)
{
    if (urlStr != null) {
        if ((-1 == urlStr.indexOf("?")) &&
        (-1 != urlStr.indexOf("="))) {
            var pos = urlStr.lastIndexOf("/");
            urlStr = urlStr.substring(0, pos + 1) +
            "?" +
            urlStr.substring(pos + 1, urlStr.length);
        }
    }
    return urlStr;
}

// helper method to call app's custom URL scheme ("zswebformscheme://") interface
function executeURLString(urlStr) {

    urlStr = fixBadURLString(urlStr);

    console.log('executeURLString: ' + urlStr);

    window.location.href = urlStr;
}

// tell app to check PIN before saveing form's data
function requestSave() {
    console.log('requestsave');
    var pin = $('#pwTomedo').val();

    var urlStr = tomedoUrlScheme + '://' + 'requestsave=' + pin;

    console.log('requestsave urlStr: ' + urlStr);

    executeURLString(urlStr);
}

// tell app to setup form's data
function requestjson() {

    console.log('requestjson');
    var urlStr = tomedoUrlScheme + '://requestjson';
    console.log('requestjson: ' + urlStr);
    executeURLString(urlStr);
}

// if patient wants to close the form without saving
function requestBackWithoutSave() {

    console.log('requestBackWithoutSave');
    var pin = $('#pwTomedo').val();

    var urlStr = tomedoUrlScheme + '://' + 'requestclosewithoutsave=' + pin;

    console.log('requestclosewithoutpin urlStr: ' + urlStr);

    executeURLString(urlStr);
}

// if doc watches an locked form
function requestCloseWithoutPin() {

    var urlStr = tomedoUrlScheme + '://' + 'requestclosewithoutpin';
    console.log('requestclosewithoutpin urlStr: ' + urlStr);
    executeURLString(urlStr);
}

// tell app to print form
function requestPrint() {

    var urlStr = tomedoUrlScheme + '://' + 'requestprint';
    console.log('requestprint urlStr: ' + urlStr);
    executeURLString(urlStr);
}

// tell app to save form's data
function savejson( jsonString ) {

    console.log('savejson');
    var urlStr = tomedoUrlScheme + '://' + 'savejson=' + encodeURIComponent(jsonString);
    console.log('savejson: ' + urlStr);
    executeURLString(urlStr);
}

// --------------------------------------------------------------------------------
// public interface functions (used by app)
// --------------------------------------------------------------------------------

// public interface function:
// - used by app to fill DOM elements wit JSON data
// - jsonString(String): percent escaped JSON data
// - JSON data is devided in two parts:
// a) persisted JSON data, contains entered or preset data of DOM elements (input/textarea/canvas), read-write
// b) read-only data to prefill DOM elements, they would not be saved (e.g. patient, doctor)
function prefillform(jsonString) {

    if (!PRODUCTION_MODE) {
        jsonString = window.localStorage['formdataDict'];
    }

    if (jsonString == null || jsonString == "") {
        console.log('prefillform: no formdataDict string in localStorage!!!');
        jsonString = '{}';
    }
    else {
        console.log('prefillform: ' + jsonString);
    }

    jsonString = decodeURIComponent(jsonString);


    formdataDict = JSON.parse(jsonString);

    if (!formdataDict) {
        console.log('prefillform: no formdataDict!!!');
        formdataDict = {};
    }

    console.log('formdataDict' + JSON.stringify(formdataDict));

    // handle form is locked flag: read-only mode
    if (formdataDict.hasOwnProperty('isFormLocked')) {
        isFormLocked = formdataDict['isFormLocked'];
    }

    // setup form data from JSON map/dictionary
    prefillReadOnlyData(formdataDict);
    prefillData(formdataDict);

    var patientenAdresse = $('#patientenanschrift');
    if (patientenAdresse && formdataDict['patientenanschrift']) {

        patientenanschrift = formdataDict['patientenanschrift'];

        var adressHTML = '';
        adressHTML += patientenanschrift['patientVollname'] + '<br/>';
        adressHTML += patientenanschrift['strasse'] + '<br/>';
        adressHTML += patientenanschrift['plz'] + ' ' + patientenanschrift['ort'];

        $('#patientenanschrift').html(adressHTML);
    }

    appInit();
}

// public interface function: handlewrongpin()
// - on save data, on cancel
// - used by app to tell JS that entered PIN wasn't correct, so that form data couldn't be saved now
function handlewrongpin() {

    console.log('handlewrongpin');
    var pin = $('#pwTomedo').val('');
    alert('Falsche Pin');
}

// public interface function: handlepinsuccess()
// - on save data
// - used by app to tell JS that PIN was successfully verfied, that form data now could be saved
function handlepinsuccess() {

    console.log('handlepinsuccess');
    saveform();
}

// public interface function:
// - on save data, after PIN was successfully checked or immediately if no PIN is required for form batch mode
// - used by app to tell JS to collect data from DOM elements, convert it into JSON format and transfer data to app
function saveform() {

    console.log('saveForm');
    formdataDict = {};

    var allObjects = $('.zs-data');

    console.log('saveForm canvases: ', JSON.stringify(canvases));

    $(allObjects).each(function(index, element) {

        console.log('element.tagName: ', element.tagName);

        switch (element.tagName) {
        case 'INPUT':
        case 'TEXTAREA':
            saveInput(element);
            break;
        case 'CANVAS':
            saveCanvas(element);
            break;
        }
    });

    formdataDict['isFormLocked'] = isFormLocked;
    formdataDict['webformnameandversion'] = webformnameandversion;
    if (patientenanschrift) {
        formdataDict['patientenanschrift'] = patientenanschrift;
    }

    var jsonString = JSON.stringify(formdataDict);

    if (PRODUCTION_MODE) {
        savejson(jsonString);
    }
    else {
        localStorage['formdataDict'] = jsonString;
    }
}

// --------------------------------------------------------------------------------
// reset functions:
// --------------------------------------------------------------------------------

function resetButtonClicked() {

    console.log('resetButtonClicked');
    var allObjects = $('.zs-data');

    $(allObjects).each(function(index, element) {

        console.log('resetButtonClicked: ', element);

        switch (element.tagName) {
        case 'INPUT':
        case 'TEXTAREA':
            resetInput(element);
            break;
        case 'CANVAS':
            resetCanvas(element);
            break;
        }
    });

    formdataDict = {};
}

function resetInput(element) {
    console.log('resetInput: ', element);

    switch (element.type) {
    case 'text':
    case 'textarea':
        element.value = '';
        break;
    case 'checkbox':
    case 'radio':
        element.checked = false;
        break;
    }
}

function resetCanvas(canvas) {
    console.log('resetCanvas: ', canvas);

    // reset canvas's data
    canvases[ canvas.id ] = Array();

    // reset canvas draw area
    var context = context2dForCanvas( canvas );
    context.clearRect(0, 0, canvas.width, canvas.height);
}

// --------------------------------------------------------------------------------
// save functions:
// --------------------------------------------------------------------------------

function saveInput(input) {

    if ((input.type === 'radio' || input.type === 'checkbox') && (input.checked == false)) {

        return;
    }

    var data = {};
    data['tagName'] = input.tagName;
    data['type'] = input.type;
    data['name'] = input.name;
    data['value'] = input.value;
    if ($(input).hasClass('datepicker')) {
        data['datepicker'] = true;
    }

    console.log('saveInput: ' + JSON.stringify(data));

    formdataDict[input.id] = data;

    console.log('saveInput: ' + JSON.stringify(formdataDict));

}

// we save all canvas contents in one step by
// storing the canvases dict
function saveCanvas(canvas) {

    console.log('tag:' + canvas.tagName +
    ' id:' + canvas.id +
    ' data:' + canvases[canvas.id]);

    // save the contents of the canvases
    var data = {};
    data['tagName'] = canvas.tagName;
    data['data'] = canvases[canvas.id];
    console.log('saveCanvas id:' + canvas.id + ' data:' + data['data']);
    formdataDict[canvas.id] = data;
}

// --------------------------------------------------------------------------------
// prefill functions:
// --------------------------------------------------------------------------------

// fills DOM elements with special read-only data from JSON dictionary/map
function prefillReadOnlyData(json) {

    if (!json)
        return;

    var varPattern = /\[[a-zA-Z_][a-zA-Z_0-9]*([.][a-zA-Z_][a-zA-Z_0-9]*)*\]/;
    var textPattern = /[^[]+/;
    var fieldPattern = new RegExp(varPattern.source + '|' + textPattern.source, "g");

    // pre-fill special fields marked with class "zs-fill"
    $(".zs-fill").each(function( index , element ) {

        // check, if name need to be parsed
        if (this.name == null)
            return;

        // check, if data exists for element, which has precedence
        if (element.id && json.hasOwnProperty(element.id))
            return;

        // split name into fields with which it should be filled and separators which keep so as the are
        var name = this.name;
        var items = name.match(fieldPattern);

        // each item ...
        var value = "";
        while (items.length > 0)
        {
            // extract next item
            var item = items.shift();

            // no var, so it is a text, append it as it is
            if (!varPattern.test(item))
            {
                value = value + item;
                continue;
            }

            // if it is a variable name, remove braces and split variable name by dots
            var keyPath = item.substring( 1 , item.length - 1 );
            var keys    = keyPath.split( "." );

            // go through variable's child hirarchy and put the value into result
            var v = json;
            keys.forEach(function( key ) {
                v = ( v && v.hasOwnProperty( key ) ) ? v[ key ] : null;
            });

            // finally add content of variable to the resulting value
            if (v)
                value = value + v;
        }

        // set value of current DOM element
        element.value = value;
    });

}

// fills DOM elements with data from JSON dictionary/map
function prefillData(json)
{

    if (!json)
        return;

    // setup data, each element from JSON array ...
    for (var id in json) {

        // check, if property is not an attribute from map's/dictionary's prototype class
        if (!json.hasOwnProperty(id))
            continue;

        // check, if at least one DOM element of that id exists
        if (!document.getElementById(id))
            continue;

        var dict = json[id];
        var tagName = dict['tagName'];

        // canvas
        if (tagName === 'CANVAS') {
            prefillCanvas(id, dict['data']);
        }


        else // input / textarea
        if ((tagName === 'INPUT') || (tagName === 'TEXTAREA')) {

            var type = dict['type'];

            // input: text / textarea
            if ((type === 'text') || (type === 'textarea')) {
                var value = dict['value'];
                prefillTextInput(id, value)
            }


            else // input: checkbox
            if (type === 'checkbox') {
                prefillCheckbox(id);
            }


            else // input: radio
            if (type === 'radio') {
                prefillRadio(id);
            }
        }
    }

}

function prefillCanvas(id, data) {

    drawLinesInCanvas(id, data);
    canvases[id] = data;
    console.log('prefillCanvas canvases[id]: ' + JSON.stringify(canvases[id]));
}

function prefillTextInput(id, value) {

    var elem = document.getElementById(id);
    if (elem) {
        elem.value = value;
    }
}

function prefillCheckbox(id) {

    var elem = document.getElementById(id);
    if (elem) {
        elem.checked = true;
    }
}

function prefillRadio(id) {

    var elem = document.getElementById(id);
    if (elem) {
        elem.checked = true;
    }
}

// --------------------------------------------------------------------------------
// lock functions:
// --------------------------------------------------------------------------------

function setupForLockedForm() {

    var allObjects = $('.zs-data');
    $(allObjects).each(function(index, element) {

        console.log('element.tagName: ', element.tagName);

        switch (element.tagName) {
        case 'INPUT':
        case 'TEXTAREA':
            disableInput(element);
            break;
        }
    });

    $('#modalText').html('Das Formular ist für die Bearbeitung gesperrt');

    $('#pinForm').css("display", "none");
    $('#modalzurueckZuTomedoButton').css("display", "none");
    $('#modalConfirmSaveButton').css("display", "none");
    $('#modalConfirmSaveAndLockButton').css("display", "none");
    $('#resetButton').css("display","none");

    $('#modalzurueckZuTomedoButton').css("display", "inline-block");
}

function disableInput(element) {
    $(element).attr("disabled", "true");
}
